<stylesheet
	xmlns="http://www.w3.org/1999/XSL/Transform"
	xmlns:seaf="http://seaf.sf.net/seaf"
	xmlns:jbg="http://jbg.sf.net/jbg"
	version="2.0">
<import href="functions/JbgBusinessFunctions.xsl" />
<output method="text" />

<template match="//jbg:beans[@chainable-setters='yes']/jbg:bean">
	<variable name="bean" select="." />
	<variable name="bean-class" select="seaf:type-class(@class)" />
	<variable name="class" select="concat($bean-class,'BeanInfo')" />
	<variable name="dir" select="seaf:type-dir(@class)" />
	<variable name="package" select="seaf:type-package(@class)" />
	<variable name="all-properties" select="jbg:all-bean-properties(.)" />

<if test="$all-properties">
	<!-- Trace the names of files generated: 
	<message select="concat('Creating BeanInfo ',$dir,'/',$class,'.java')" />
	 -->

<result-document href="{$dir}/{$class}.java">
<text />/**
 * GENERATED BY JavaBeans Generator. DO NOT EDIT.
 */
package <value-of select="$package" />;

import java.beans.BeanInfo;
import java.beans.IntrospectionException;
import java.beans.PropertyDescriptor;
import java.beans.SimpleBeanInfo;

import net.sf.seaf.exception.SeafRuntimeException;

/**
 * BeanInfo for the <value-of select="$bean-class" />
	<text /> JavaBean. The bean has chainable setters, which
 * requires a BeanInfo for the JavaBean {@link java.beans.Introspector} to recognize the
 * setters.
 */
public class <value-of select="$class" /> extends SimpleBeanInfo implements BeanInfo {

	@Override
	public PropertyDescriptor[] getPropertyDescriptors() {
		try {
			PropertyDescriptor[] ds = new PropertyDescriptor[] {<text />
	<for-each select="$all-properties">
		<variable name="name" select="@name" />
		<variable name="setter" select="seaf:setter-name($name)" />
		<variable name="getter" select="seaf:getter-name($name)" />
				new PropertyDescriptor("<text />
					<value-of select="$name" />", <text />
					<value-of select="$bean-class" />.class, "<text />
					<value-of select="$getter" />", "<text />
					<value-of select="$setter" />")<text />
		<if test="not(position()=last())">,</if>
	</for-each>
			};
			return ds;
		} catch (IntrospectionException e) {
			e.printStackTrace();
			String message = "Cannot create property descriptor";
			throw new SeafRuntimeException(message, e);
		}
	}

}
<text />
</result-document>
</if>
</template>

</stylesheet>
