<stylesheet
	xmlns="http://www.w3.org/1999/XSL/Transform"
	xmlns:xs="http://www.w3.org/2001/XMLSchema" 
	xmlns:seaf="http://seaf.sf.net/seaf"
	xmlns:jbg="http://jbg.sf.net/jbg"
	version="2.0">
<import href="generator/seaf-commons/CommonBusinessFunctions.xsl" />

	<variable name="nl4">
		<text>
				</text>
	</variable>

	<!-- Return Java equivalent of a simple type -->
	<function name="jbg:simple-type" as="xs:string">
		<param name="type" as="node()" />
		<choose>
			<when test="$type/@type='byte'">byte</when>
			<when test="$type/@type='int'">Integer</when>
			<when test="$type/@type='long'">Long</when>
			<when test="$type/@type='float'">Float</when>
			<when test="$type/@type='double'">Double</when>
			<when test="$type/@type='string'">String</when>
			<when test="$type/@type='boolean'">Boolean</when>
			<when test="$type/@type='calendar'">java.util.Calendar</when>
			<when test="$type/@type='date'">java.util.Date</when>
			<when test="$type/@type='enum' and not($type/@class)">Enum&lt;?></when>
			<when test="$type/@type='enum' and $type/@class">
				<value-of select="$type/@class" />
			</when>
			<otherwise>ERROR: unknown simple-type.</otherwise>
		</choose>
	</function>

	<function name="jbg:is-sequence-collection" as="xs:boolean">
		<param name="sequence" as="node()" />
		<value-of select="$sequence/@type='collection' or $sequence/@type='list'" />
	</function>

	<function name="jbg:property-type" as="xs:string">
		<param name="property" as="node()" />
		<choose>
			<when test="$property/jbg:simple-type">
				<value-of select="jbg:simple-type($property/jbg:simple-type)" />
			</when>
			<when test="$property/jbg:bean-type">
				<value-of select="$property/jbg:bean-type/@type" />
			</when>
			<when test="$property/jbg:sequence[@type='collection']">
				<value-of
					select="concat('java.util.Collection&lt;',
					jbg:property-type($property/jbg:sequence),'>')" />
			</when>
			<when test="$property/jbg:sequence[@type='list']">
				<value-of
					select="concat('java.util.List&lt;',
					jbg:property-type($property/jbg:sequence),'>')" />
			</when>
			<when test="$property/jbg:sequence[@type='array']">
				<value-of select="concat(jbg:property-type($property/jbg:sequence),'[]')" />
			</when>
		</choose>
	</function>

	<function name="jbg:constructor-declaration" as="xs:string">
		<param name="bean-class" as="xs:string" />
		<param name="properties" as="node()*" />
		<param name="label" as="xs:string" />

		<variable name="result">

	/**
	 * <value-of select="$label"/> constructor of JavaBean <text />
	 	<value-of select="$bean-class"/>.
	 * <text />
	<for-each select="$properties">
	 * @param <value-of select="@name" />
		<if test="jbg:description">
			<text> </text>
			<value-of select="jbg:description[1]" />
		</if>
	</for-each>
	 */
	public <value-of select="$bean-class"/>(<text />
	<for-each select="$properties">
		<variable name="name" select="@name" />
		<variable name="type" select="jbg:property-type(.)" />
		<text>
			</text>
		<value-of select="concat($type,' ',$name)" />
		<if test="not(position()=last())">, </if>
	</for-each>
	<text />) {<text />
	<for-each select="$properties">
		<variable name="name" select="@name" />
		<text>
		</text>
		<value-of select="concat(seaf:setter-name($name),'(',$name,');')" />
	</for-each>
	}<text />
		</variable>
		<value-of select="$result"/>
	</function>

	<function name="jbg:class-comment" as="xs:string">
		<param name="bean-class" as="xs:string" />
		<param name="comments" as="node()*" />

		<variable name="result">

/**<text />
<choose>
<when test="not(empty($comments))">
	<for-each select="$comments">
 * <value-of select="." />
		<if test="not(position()=last())">
 * &lt;p><text />
		</if>
	</for-each>
</when>
<otherwise>
 * JavaBean <value-of select="$bean-class" />. Generated by JBG.<text />
</otherwise>
</choose>
 */<text />
		</variable>
		<value-of select="$result"/>
	</function>

	<!-- Generate declaration of an attribute -->
	<function name="jbg:attribute-declaration">
		<param name="name" as="xs:string" />
		<param name="type" as="xs:string" />
		<param name="initial-value" as="xs:string*" />
		<param name="descriptions" as="xs:string*" />
		<param name="annotations" as="xs:string*" />
		<text />

	/**<text />
		<choose>
		<when test="not(empty($descriptions))">
			<for-each select="$descriptions">
				<if test="not(position()=1)">
	 * &lt;p><text />
	 			</if>
	 * <value-of select="." />
			</for-each>
		</when>
		<otherwise>
	 * Property <value-of select="$name" />.<text />
		</otherwise>
		</choose>
	 */<text />
		<for-each select="$annotations">
			<text>
	</text>
			<value-of select="." />
		</for-each>
	private <text />
		<value-of select="$type" />
		<text> </text>
		<value-of select="$name" />
		<if test="$initial-value">
			<text>
			= </text>
			<value-of select="$initial-value"/>
		</if>
		<text>;</text>
	</function>

	<function name="jbg:to-string-method" as="xs:string">
		<param name="bean-class" as="xs:string" />
		<param name="properties" as="node()*" />
		<variable name="result">

	@Override
	public String toString() {
		ToStringUtils u = new ToStringUtils(<text />
			<value-of select="$bean-class" />.class, super.toString());<text />
		<for-each select="$properties">
			<variable name="is-temporal" select="jbg:is-temporal(jbg:simple-type/@type)" />
		u.addProperty("<text />
			<value-of select="@name"/>", <text />
			<if test="$is-temporal">ConverterToString.convert(</if>
			<value-of select="seaf:getter-name(@name)"/>()<text />
			<if test="$is-temporal">, TemporalType.TIMESTAMP)</if>
			<text />);<text />
		</for-each>
		return u.toString();
	}<text />
		</variable>
		<value-of select="$result"/>
	</function>

	<function name="jbg:is-temporal" as="xs:boolean">
		<param name="source-temporal-type" as="xs:string*" />
		<value-of select="$source-temporal-type='date' or $source-temporal-type='calendar'" />
	</function>

	<function name="jbg:hash-code-method" as="xs:string">
		<param name="bean-class" as="xs:string" />
		<variable name="result">

	@Override
	public int hashCode() {
		int superHashCode = 0;
		if (!<value-of select="$bean-class" />.class.getSuperclass().equals(Object.class)) {
			superHashCode = super.hashCode();
		}
		return HashCodeUtils.hashCodeFor(superHashCode, businessKeyValues());
	}<text />
		</variable>
		<value-of select="$result"/>
	</function>

	<function name="jbg:get-business-key-values-method" as="xs:string">
		<param name="properties" as="node()*" />
		<variable name="result">

	/**
	 * Return the values of the business key properties of the bean.
	 * 
	 * @return Object[]
	 */
	private Object[] businessKeyValues() {
		return new Object[] {<text />
		<for-each select="$properties">
			<text>
			</text>
			<value-of select="seaf:getter-name(./@name)"/>
			<text>()</text>
			<if test="not(position()=last())">,</if>
		</for-each>
		};
	}<text />
		</variable>
		<value-of select="$result"/>
	</function>

	<function name="jbg:equals-method" as="xs:string">
		<param name="bean-class" as="xs:string" />
		<variable name="result">

	@Override
	public boolean equals(Object object) {
		if (this == object) {
			return true;
		}
		if (null == object) {
			return false;
		}
		if (!(getClass().equals(object.getClass()))) {
			return false;
		}
		if (!<value-of select="$bean-class" />.class.getSuperclass().equals(Object.class) <text />
				<text />&amp;&amp; !super.equals(object)) {
			return false;
		}
		final <value-of select="$bean-class" /> that = (<text />
			<value-of select="$bean-class" />) object;
		return Arrays.equals(this.businessKeyValues(), that.businessKeyValues());
	}<text />
		</variable>
		<value-of select="$result"/>
	</function>

	<function name="jbg:collection-setter-helpers" as="xs:string">
		<param name="name" as="xs:string" />
		<param name="single-type" as="xs:string" />
		<param name="reverse-name" as="xs:string*" />
		<param name="cast-as" as="xs:string*" />
		<param name="non-final" as="xs:boolean*" />
		<variable name="result">

	/**
	 * Add a new item to <value-of select="$name" /> Collection.
	 * 
	 * @param item
	 *            A new item to be added
	 */
	public <text />
		<if test="not($non-final)">final </if>
	<text />void addTo<value-of select="seaf:first-upper($name)" />(<text />
		<value-of select="$single-type" /> item) {
		this.<value-of select="$name" />.add(item);<text />
		<if test="$reverse-name">
		// Set the reverse side of the relation
		item.<value-of select="seaf:setter-name($reverse-name)" />(<text />
			<if test="$cast-as">(<value-of select="$cast-as" />) </if>
			<text />this);<text />
		</if>
	}<text />
		</variable>
		<value-of select="$result"/>
	</function>

	<function name="jbg:collection-initial-value" as="xs:string*">
		<param name="property" as="node()" />

		<variable name="result">
			<if test="$property/ancestor::jbg:beans/@keep-collections-not-null='yes' 
				and $property/jbg:sequence[jbg:is-sequence-collection(.)]">
				<text>new java.util.ArrayList&lt;</text>
				<choose>
				<when test="$property//jbg:bean-type">
					<value-of select="$property//jbg:bean-type/@type"/>
				</when>
				<otherwise>
					<value-of select="jbg:property-type($property/jbg:sequence)"/>
				</otherwise>
				</choose>
				<text>>()</text>
			</if>
		</variable>
		<value-of select="$result" />
	</function>

	<function name="jbg:to-string-properties" as="node()*">
		<param name="bean" as="node()" />

		<choose>
		<when test="$bean/ancestor::jbg:beans/@to-string-properties='all'">
			<apply-templates select="$bean/jbg:property" mode="copy" />
		</when>
		<otherwise>
			<apply-templates select="jbg:simple-properties($bean/jbg:property)" mode="copy" />
		</otherwise>
		</choose>
	</function>

	<function name="jbg:business-key-properties" as="node()*">
		<param name="bean" as="node()" />
		<variable name="properties" select="$bean/jbg:property" />

		<choose>
		<when test="$properties[@status='business-key']">
			<apply-templates select="$properties[@status='business-key']" mode="copy" />
		</when>
		<otherwise>
			<apply-templates 
				select="jbg:simple-properties($properties)[not(@status='supplementary')]" 
				mode="copy" />
		</otherwise>
		</choose>
	</function>

	<function name="jbg:bean-class-start" as="xs:string">
		<param name="class" as="xs:string" />
		<param name="to-string-all" as="xs:boolean" />
		<param name="import-simple-converters" as="xs:boolean" />
		<param name="descriptions" as="node()*" />
		<param name="assume-instance-of" as="xs:string*" />
		<param name="is-final" as="xs:boolean" />
		<param name="extends" as="xs:string*" />
		<param name="implements" as="xs:string*" />
		<param name="annotations" as="xs:string*" />
		<param name="serialUID" as="xs:string*" />

		<variable name="bean-class" select="seaf:type-class($class)" />
		<variable name="bean-package" select="seaf:type-package($class)" />
		<variable name="result">
<text />/**
 * GENERATED BY JavaBeans Generator. DO NOT EDIT.
 */
package <value-of select="$bean-package" />;

import java.util.Arrays;
<text />

<if test="$import-simple-converters">
import net.sf.seaf.util.convert.simple.*;<text />
</if>
import net.sf.seaf.util.ToStringUtils;
import net.sf.seaf.util.HashCodeUtils;<text />

<value-of select="jbg:class-comment($bean-class,$descriptions)" />
<for-each select="$annotations">
	<text>
</text>
	<value-of select="." />
</for-each>
public <text />
<if test="$assume-instance-of">abstract </if>
<if test="$is-final">final </if>
<text />class <value-of select="$bean-class" /><text />
<if test="$extends">
	<text /> extends <value-of select="$extends" />
</if>
<if test="$implements or $serialUID">
		implements <value-of select="$implements" />
		<if test="$implements and $serialUID">, </if>
		<if test="$serialUID">java.io.Serializable</if>
</if>
<text /> {<text />
		</variable>

		<value-of select="$result"/>
	</function>

	<function name="jbg:report-property-type" as="xs:string*">
	<param name="property" as="node()" />

		<choose>
		<when test="$property/jbg:simple-type">
			<choose>
			<when test="$property/jbg:simple-type/@type='string'">String</when>
			<when test="$property/jbg:simple-type/@type='byte'">byte</when>
			<when test="$property/jbg:simple-type/@type='int'">Int</when>
			<when test="$property/jbg:simple-type/@type='long'">Long</when>
			<when test="$property/jbg:simple-type/@type='float'">Float</when>
			<when test="$property/jbg:simple-type/@type='double'">Double</when>
			<when test="$property/jbg:simple-type/@type='boolean'">Boolean</when>
			<when test="$property/jbg:simple-type/@type='calendar'">Calendar</when>
			<when test="$property/jbg:simple-type/@type='date'">Date</when>
			<when test="$property/jbg:simple-type/@type='enum'">Enum</when>
			</choose>
			<if test="$property/jbg:simple-type/@class">
				<variable name="label" select="$property/jbg:simple-type/@class" />
				<variable name="link" select="concat('#bean_',$label)" />
				<value-of select="concat('[',seaf:hyperlink($link,$label),']')"/>
			</if>
		</when>
		<when test="$property/jbg:bean-type">
			<variable name="label" select="$property/jbg:bean-type/@type" />
			<variable name="link" select="concat('#bean_',$label)" />
			<value-of select="seaf:hyperlink($link,$label)"/>
		</when>
		<when test="$property/jbg:sequence">
			<choose>
			<when test="$property/jbg:sequence/@type='collection'">Collection</when>
			<when test="$property/jbg:sequence/@type='list'">List</when>
			<when test="$property/jbg:sequence/@type='array'">Array</when>
			</choose>
			<value-of select="concat('[',jbg:report-property-type($property/jbg:sequence),']')"/>
		</when>
		</choose>
	</function>

	<function name="jbg:all-bean-properties" as="node()*">
	<param name="bean" as="node()" />
		<variable name="extends" select="$bean/@extends" />
		<variable name="parent" select="$bean/parent::*/parent::*//jbg:bean[@class=$extends]" />

		<if test="$parent">
			<apply-templates select="jbg:all-bean-properties($parent)" mode="copy" />
		</if>
		<apply-templates select="$bean/jbg:property" mode="copy" />
	</function>

	<function name="jbg:simple-properties" as="node()*">
	<param name="all-properties" as="node()*" />
		<copy-of select="$all-properties[jbg:simple-type or jbg:bean-type/@treat-as-simple=true()]" />
	</function>

	<function name="jbg:serial-uid" as="xs:string">
		<param name="serializable-with-id" as="xs:string*" />
		<variable name="result">
			<if test="$serializable-with-id">

	private static final long serialVersionUID = <text />
		<value-of select="$serializable-with-id" />L;<text />
			</if>
		</variable>
		<value-of select="$result" />
	</function>

</stylesheet>
